package pile;

public class PileTableau<Type> implements Pile<Type> {
	private Object contenu[];
	private int nbElem;
	public PileTableau(int tailleInitiale) {
		contenu = new Object[tailleInitiale];
		nbElem = 0;
	}
	public boolean estVide() {
		return nbElem == 0;
	}
	public int taille() {
		return nbElem;
	}
	@SuppressWarnings("unchecked")
	public Type sommet() {
		return (Type)(contenu[nbElem - 1]);
	}
	public void empile(Type e) {
		if (nbElem == contenu.length) {
			Object nouveauContenu[] = new Object[2 * contenu.length];
			for (int i = 0; i < nbElem; i++)
				nouveauContenu[i] = contenu[i];
			contenu = nouveauContenu;
		}
		contenu[nbElem++] = e;
	}
	public void depile() {
		nbElem--;
	}
}
