package application;

import pile.Pile;
import pile.PileTableau;

public class EssaiPile {
	public static void main(String[] args) {
		Pile<String> p = new PileTableau<String>(5);
		String valeurs[] = {"un", "deux", "trois", "quatre", "cinq", "six"};
		for (String s : valeurs) {
			System.out.println("Ajout de " + s + ".");
			p.empile(s);
			System.out.println("Nombre d'éléments dans la pile : " + p.taille());
		}
		while (!p.estVide()) {
			System.out.println("Sommet de pile " + p.sommet() + " va être retiré...");
			p.depile();
		}
	}
}
